	let express    = require('express');
	let exec       = require('child_process').exec;		

	

function prepareClientFolder(clientName, fileName){
return new Promise((resolve,reject)=>{

exec('cp -R ' + fileName + '/ ' + clientName + '/',(error,stdout,stderr)=>{

		if (error) {
				reject(error);
				return;
			}

			console.log(stdout);
			console.log(stderr);

			resolve(fileName);

})	
})


}

	function frontendClean(clientName, fileName){
		return new Promise((resolve, reject) => {
			
			exec('cd ' + clientName + '/' + fileName + ' && git checkout package.json && npm prune ', (error, stdout, stderr) => {

				if (error) {
					reject(error)
					return;
				}

				console.log(stdout);
				console.log(stderr);
				resolve();
			});
		})

	}


	function frontendPull(clientName, fileName){

		return new Promise((resolve, reject) => {
			
			exec('cd ' + clientName + '/' + fileName +' && git pull ', (error, stdout, stderr) => {

				if (error) {
					reject(error)
					return;
				}

				console.log(stdout);
				console.log(stderr);
				resolve();
			});
		})
	} 

	function frontendInstallAddons(clientName, fileName, checkedFiles, downloadFiles){
		
		return new Promise((resolve, reject) => {

			checkedPlugins = checkedFiles.filter(function(file){
				return /\bexplorviz-frontend-plugin-\w*/.exec(file);
			});

			if(checkedPlugins.length !== 0 ){
				checkedPlugins.forEach((pluginName) => {
					//TODO now addon is listed under dependencies-section in package.json
					exec('cd ' + clientName + '/' + fileName + ' && ember install ' + downloadFiles[pluginName] + ' --save', (error, stdout, stderr) => {
						
						if (error) {
							reject(error);
							return;
						}

						console.log(stdout);
						console.log(stderr);

						resolve();

					});

				})
				//If no plugins were checked by the user, the downloader skips this step by resolving immediately.
			} else {
				resolve();
			}

		})
	}

	function frontendBuild(clientName, fileName){

		return new Promise((resolve,reject)=> {
			
			exec('cd ' + clientName + '/' + fileName + ' && ember build --environment=production', (error, stdout, stderr) => {

				if (error) {
					reject(error);
					return;
				}

				console.log(stdout);
				console.log(stderr);

				resolve({zipFileName:'frontend', path: clientName + '/explorviz-ui-frontend/dist/'});
			});



		})
		
	}

	module.exports = {
		prepareClientFolder,
		frontendClean,
		frontendPull,
		frontendInstallAddons,
		frontendBuild
	}
