const express    = require('express');
const exec       = require('child_process').exec;

  //Clone the git repos initially for performance.
  function initialize(downloadFiles){
    return initBackend(downloadFiles).then(function(downloadFiles){
      return initBackendPlugins(downloadFiles).then(function(downloadFiles){
        return initFrontend(downloadFiles)
      })
    })
  };


  function initBackend(downloadFiles){
    const backendName= 'explorviz-ui-backend';
    const downloadBackendURL = downloadFiles[backendName];

    return new Promise((resolve,reject)=>{
      exec('git clone ' + downloadBackendURL + ' '+ backendName, (error, stdout, stderr) => {

        if (error) {
          reject(error);
          return;
        }

        console.log(stdout);
        console.log(stderr);
      });
      resolve(downloadFiles);

    });
  }

  function initBackendPlugins(downloadFiles){
   downloadNames = Object.keys(downloadFiles);
   
   const backendPlugins = downloadNames.filter(function(file){
    return /\bexplorviz-backend-plugin-\w*/.exec(file);
  });

   return new Promise((resolve, reject) => {
     if(backendPlugins.length !== 0 ){

      backendPlugins.forEach((pluginName) => {
        exec('git clone ' + downloadFiles[pluginName], (error, stdout, stderr) => {

          if (error) {
            reject(error);
            return;
          }

          console.log(stdout);
          console.log(stderr);

          resolve(downloadFiles);

        });

      })
    } else {
      resolve(downloadFiles);
    }

  })



 }

 function initFrontend(downloadFiles){

  return new Promise((resolve,reject)=>{

    const frontendName ='explorviz-ui-frontend';
    const downloadFrontendURL = downloadFiles[frontendName];
    exec('git clone ' + downloadFrontendURL + ' ' + frontendName + ' && cd '+ frontendName + ' && npm install', (error, stdout, stderr) => {

      if (error) {
        reject(error);
        return;
      }

      console.log(stdout);
      console.log(stderr);
    });
    resolve();
    
  })

};

module.exports = {
  initialize
}